// serverws.ip = "IP MACHINE DCS"; // défaut localhost
// serverws.port = "PORT";	// défaut 9000
// serverws.auto_connect = true;
// serverws.delay = 5000;

var mydata;
var obj;
var mytimer;
var my2timer;
var paneldata = new Array();
var Panel_On = {};
var KaTZPit_data = {};
var Plane_data = {};
var FL_data = {};
var RWY_data = {};
var Weapon_data={};
var Order_List = new Array();
var Cmd_Capot = {};
var CmdDelay;




window.onload = function(){

// Chargement et indication de l'IP et Port
// Sur le panel Emergency
panel_emergency_update(KaTZPit_data)

// Initialisation des Panels affichés
	Panel_On = panel_On_init();
	Panel_Toggle("Init")
	
	
//mytimer = setInterval(main, 200);

}


function main(){

	// Iteration Principale, fréquence fixée dans mytimer
		
	panel_emergency_update(KaTZPit_data)
	panel_analog_update(KaTZPit_data)
	
	panel_rotor_update(KaTZPit_data)
	
	panel_radio_update(KaTZPit_data)
	
	// Lancement des subroutines en fonction des panneaux affichés dans le KaKZ_Pit
	if (Panel_On["APU"]==1){panel_apu_update(KaTZPit_data)}
	if (Panel_On["Oil"]==1){panel_oil_update(KaTZPit_data)}
	if (Panel_On["Start"]==1){panel_start_update(KaTZPit_data)}
	if (Panel_On["Electric_DC"]==1 || Panel_On["Electric_AC"]==1){panel_electric_update(KaTZPit_data)}
	// if (Panel_On["Rotor"]==1){panel_rotor_update(KaTZPit_data)}
	if (Panel_On["Doppler"]==1){panel_doppler_update(KaTZPit_data)}
	if (Panel_On["ARK_9"]==1){panel_ark9_update(KaTZPit_data)}
	if (Panel_On["ARK_UD"]==1){panel_arkud_update(KaTZPit_data)}
	if (Panel_On["Fuel"]==1){panel_fuel_update(KaTZPit_data)}	
	
	
	CmdSend()
}

// Fonction d'affichage des sous Panels, appelée depuis la barre de Launcher
function Panel_Toggle(panel){
	
	Panel_On[panel] = (Panel_On[panel]+1) % 2
	console.log(panel," = ",Panel_On[panel])
	
	if (Panel_On["APU"] == 0) {document.getElementById("Panel_APU").style.display = "none"}
	else {document.getElementById("Panel_APU").style.display = "block"}

	if (Panel_On["Start"] == 0) {document.getElementById("Panel_Start").style.display = "none"}
	else {document.getElementById("Panel_Start").style.display = "block"}
	
	if (Panel_On["Oil"] == 0) {document.getElementById("Panel_Oil").style.display = "none"}
	else {document.getElementById("Panel_Oil").style.display = "block"}

	if (Panel_On["Rotor"] == 0) {document.getElementById("Panel_Rotor").style.display = "none"}
	else {document.getElementById("Panel_Rotor").style.display = "block"}
	
	if (Panel_On["Fuel"] == 0) {document.getElementById("Panel_Fuel").style.display = "none"}
	else {document.getElementById("Panel_Fuel").style.display = "block"}


	if (Panel_On["Radio_360"] == 0) {document.getElementById("Panel_Radio").style.display = "none"}
	else {document.getElementById("Panel_Radio").style.display = "block"}

	if (Panel_On["Breakers"] == 0) {document.getElementById("Panel_Circuit_Breaker").style.display = "none"}
	else {document.getElementById("Panel_Circuit_Breaker").style.display = "block"}
	
	if (Panel_On["Electric_DC"] == 0) {document.getElementById("Panel_Electric_DC").style.display = "none"}
	else {document.getElementById("Panel_Electric_DC").style.display = "block"}
	
	if (Panel_On["Electric_AC"] == 0) {document.getElementById("Panel_Electric_AC").style.display = "none"}
	else {document.getElementById("Panel_Electric_AC").style.display = "block"}
	
	if (Panel_On["ARK_9"] == 0) {document.getElementById("Panel_ARK_9").style.display = "none"}
	else {
		// Affichage de l'ARK-9
		document.getElementById("Panel_ARK_9").style.display = "block"
		// On desactive l'affichage des fréquences temporaires #ARK9-temp-Main
		document.getElementById("ARK9-temp-Main").style.display = "none"
		document.getElementById("ARK9-temp-Stby").style.display = "none"
		// On précharge les fréquences temporaires avec les fréquences actuelles
		var ARK9_freq = dataread_split_2(KaTZPit_data["ARK9_F"])
		KaTZPit_data["ARK9_T_Main"] = 	ARK9_freq [0]
		KaTZPit_data["ARK9_T_Stby"]	= 	ARK9_freq [1]
	}
	
	if (Panel_On["ARK_UD"] == 0) {document.getElementById("Panel_ARK_UD").style.display = "none"}
	else {document.getElementById("Panel_ARK_UD").style.display = "block"}
	
	if (Panel_On["Doppler"] == 0) {document.getElementById("Panel_Doppler").style.display = "none"}
	else {document.getElementById("Panel_Doppler").style.display = "block"}

	//if (Panel_On["Analog_1"] == 0) {document.getElementById("Panel_APU").style.display = "none"}
	//else {document.getElementById("Panel_APU").style.display = "block"}

	//if (Panel_On["Analog_2"] == 0) {document.getElementById("Panel_APU").style.display = "none"}
	//else {document.getElementById("Panel_APU").style.display = "block"}
}	
	


// Fonction appelée par appui sur le bouton KaTZ-Pit START
function Pit_Start(plane){
	// Demarrage du Panel par appui sur le bouton Start
	console.log("Demarrage Panel")

	// Initialisation des données KaTZ-Pit
	KaTZPit_data = paneldata_init();
	// Initialisation des données de position de pistes
	RWY_data = RWY_init();
	// Initialisation des modes de vol
	FL_data = fl_mode_init();
	// Initialisation de la nomenclature des armements
	Weapon_data = weapon_name_type()
	
	// Initialisation des capots de switch
	Cmd_Capot = Cmd_Capot_init()
	
	// Initialisation des Panels affichés ... dans windows on load
	//Panel_On = panel_On_init();
	//Panel_Toggle("Init")
	
	// Initialisation du type d'appareil et de ses constantes
	KaTZPit_data["Plane_Id"] = plane
	
	if (plane == 50) {
		Plane_data = KA50_init()
		KaTZPit_data["Radiotype"]=1	};
	
	if (plane == 250) {
		Plane_data = KA50_init()
		KaTZPit_data["Radiotype"]=2	};
		
	if (plane == 8) {
		Plane_data = MI8_init()
		KaTZPit_data["Radiotype"]=1	};
	
	// Mi-8 panel analogique	
	if (plane == 9) {
		Plane_data = MI8_init()
		KaTZPit_data["Radiotype"]=1	};


	// Initialisation de la Radio
	panel_radio_init(KaTZPit_data);

	// Affichage Initial
	main();
	//paneldata_update(KaTZPit_data)

	// Lancement de la procédure de connection
	serverws_connect();

}


function serverws_Open(){
	// Lancement de la boucle de rafraichissement du KaTZ-Pit
	mytimer = setInterval(main, 200);
	//my2timer = setInterval(CmdSend(), 200);
}

function serverws_Message(event){

	received_msg = event.data

	// stockage du message sous forme d'objet
	var new_data = JSON.parse(received_msg)
	//console.log("message received",new_data);
	
	var dataref;
	
	// Transfert des données recues dans le tableau KaTZ-Pit_Data
	for (dataref in new_data){
		KaTZPit_data[dataref]=new_data[dataref]
		}
		
	// Si reception d'un Ping sur le canal 8, on répond sur le canal 7
	if (KaTZPit_data["Ping"] != KaTZPit_data["Ping_old"]){
		CmdSiocSpe(7, KaTZPit_data["Ping"])
		KaTZPit_data["Ping_old"] = KaTZPit_data["Ping"]
	}
		
}

function serverws_Close(){
	// Arrêt de la boucle de rafraichissement du KaTZ-Pit
	clearInterval(mytimer);
}

// Envoi de Commande vers Sioc>DCS, Argument Num voir Liste des Commandes DCS 







